#ifndef __SPARSE_H__
#define __SPARSE_H__

struct crsMatrix
{
  int N;  //   (N x N)
  int NZ; // -  

  //   ( NZ)
  double* Value;
  //    ( NZ)
  int* Col;
  //    ( N + 1)
  int* RowIndex; 
};

//      CRS (3 ,   )
//  
//   
double Transpose1(crsMatrix imtx, crsMatrix &omtx);
double Transpose2(crsMatrix imtx, crsMatrix &omtx);

//  2     CRS (3 ,   )
//  C = A * B, C -   CRS (3 ,   )
//     C     
//    : 0 - , 1 -    (N)
//   
int Multiplicate(crsMatrix A, crsMatrix B, crsMatrix &C, double &time);

//  2     CRS (3 ,   )
//  C = A * B, C -   CRS (3 ,   )
//     C     
//    : 0 - , 1 -    (N)
//   
//         Multiplicate
//   B    
//   1)  Multiplicate (B, A)
//      B   ,   Multiplicate A  ,
//       ,   
//   2) C -> CT
//   3)   CT  C
int Multiply(crsMatrix A, crsMatrix B, crsMatrix &C, double &time);

#endif // __SPARSE_H__